#include <unistd.h>
#include <fcntl.h>
#include <sys/vfs.h>

/* TODO: use /etc/mtab, too, to find the real device for /dev/root, */
/* TODO: allow "df ." */

void dostatfs(char *device,char *mountpoint) {
  struct statfs sfs;
  int factor;
  if (statfs(mountpoint,&sfs))
    return;
  factor=sfs.f_bsize/1024;
  if (sfs.f_blocks)
    printf("%-19s %10lu %9lu %9lu %3d%% %s\n",device,
	  sfs.f_blocks*factor,
	  (sfs.f_blocks-sfs.f_bfree)*factor,
	  sfs.f_bfree*factor,
	  sfs.f_blocks?100-sfs.f_bavail*100/sfs.f_blocks:0,
	  mountpoint);
}

main(int argc, char* argv[]) {
  int fd=open("/proc/mounts",O_RDONLY);
  char buf[4096];
  int len=read(fd,buf,4096);
  int i;
  char *tmp,*max;
  puts("Filesystem           1k-blocks      Used Available Use% Mounted on");
  if (argv[1]) {
    dostatfs("-",argv[1]);
    return 0;
  }
  for (i=0,tmp=buf,max=buf+len; tmp<max; ++tmp) {
/* parse "/dev/root / reiserfs rw 0 0" */
    char *device,*mp;
#if 0
    char *fs;
#endif
    device=tmp;
    while (tmp<max && *tmp!=' ') ++tmp;
    *tmp=0;
    ++tmp;
    mp=tmp;
    while (tmp<max && *tmp!=' ') ++tmp;
    *tmp=0;
#if 0
    ++tmp;
    fs=tmp;
    while (tmp<max && *tmp!=' ') ++tmp;
    *tmp=0; ++tmp;
#endif
    while (tmp<max && *tmp!='\n') ++tmp;
    dostatfs(device,mp);
/*    printf("%s %s\n",mp,fs); */
  }
}
