#include <unistd.h>
#include <fcntl.h>
#include <pwd.h>
#include <grp.h>

#define EMBEDDED
#include "openreadclose.c"
#include "split.c"
#define DONT_NEED_PASSWD
#define DONT_NEED_MEMBERS
#include "mygetgrnam.c"
#define DONT_NEED_GECOS
#define DONT_NEED_DIR
#define DONT_NEED_SHELL
#include "mygetpwnam.c"

int main(int argc,char *argv[]) {
  int i;
  enum { ALL, GROUP, USER, GROUPS } todo=ALL;
  int name=0;
  uid_t u=geteuid();
  gid_t g=getegid();
  uid_t ru=getuid();
  uid_t rg=getgid();
  struct passwd *pw=0;
  gid_t supplementary[128];
  int size;
  char *gname=0,*uname=0;
  for (i=1; i<argc; i++) {
    int j;
    if (argv[i][0]=='-') {
      for (j=1; j<strlen(argv[i]); j++) {
	switch (argv[i][j]) {
	case 'g': todo=GROUP; break;
	case 'u': todo=USER; break;
	case 'a': todo=ALL; break;
	case 'G': todo=GROUPS; break;
	case 'r': u=ru; g=rg; break;
	case 'n': name=1; break;
	}
      }
    } else {
      pw=getpwnam(argv[i]);
      if (!pw) {
	write(2,"getpwnam failed\n",16);
	return 1;
      }
      uname=argv[i];
      u=pw->pw_uid;
      g=pw->pw_gid;
      break;
    }
  }
  switch (todo) {
  case ALL:
    if (!uname) {
      pw=getpwuid(ru);
      if (!pw) {
	write(2,"getpwuid failed\n",16);
	return 1;
      }
      uname=pw->pw_name;
    }
    {
      struct group *gr=getgrgid(rg);
      if (gr) gname=gr->gr_name;
      printf("uid=%lu(%s) gid=%lu(%s)",ru,uname,rg,gname);
      if (u!=ru) {
	uid_t ouid=pw->pw_uid;
	struct passwd *pw2=getpwuid(u);
	printf(" euid=%lu(%s)",u,pw2?pw2->pw_name:"?");
	pw->pw_uid=ouid;
      }
      if (g!=rg) {
	uid_t ogid=gr->gr_gid;
	struct group *gr2=getgrgid(g);
	printf(" egid=%lu(%s)",g,gr2?gr2->gr_name:"?");
	gr->gr_gid=ogid;
      }
      if (pw && ru==pw->pw_uid)
	if ((size=getgroups(128,supplementary))>0) {
	  printf(" groups=");
	  for (i=0; i<size; i++) {
	    gr=getgrgid(supplementary[i]);
	    printf("%s%lu(%s)",i?" ":"",supplementary[i],gr?gr->gr_name:"?");
	  }
	}
      printf("\n");
    }
    break;
  case GROUP:
    printf("%lu\n",g);
    break;
  case USER:
    printf("%lu\n",u);
    break;
  case GROUPS:
    if (!pw || (pw && ru==pw->pw_uid)) {
      if ((size=getgroups(128,supplementary))>0) {
	for (i=0; i<size; i++) {
	  printf("%s%lu",i?" ":"",supplementary[i]);
	}
      }
    } else
      printf("%lu",g);
    printf("\n");
  }
/* "uid=100(leitner) gid=100(users) groups=100(users)" */
}
